###########################################################################
#                                                                         #
# File   :	gv_menu.tcl                                               #
# Project:	TkMount                                                   #
#                                                                         #
# Started:	22.09.97                                                  #
# Changed:	22.09.97                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Description:	This file contains the hepbrowser procedure.              #
#                                                                         #
# Copyright (C) 1997 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################

###########################################################################
# initialise some variables:                                              #
###########################################################################

global delnr g2

proc gv_TraceProcDel {VarName ElemName Operation} {
  global delnr
  scan $VarName "delvar%d" delnr
  }

###########################################################################
# Load menu-description for gv_mm2-proc:                                  #
###########################################################################

proc ladeInMenuliste2 {} {
        
  global menuListe main
   
  set datname menu$main.dat
       
  catch {unset menuListe}
  catch {unset Datei}
  set menuListe ""
  cd ~/
# set Datei [open $datname r+]
  set datinfo [catch {set Datei [open $datname r+]}]
  if {$datinfo == 0} {
    while {[gets $Datei Zeile] >= 0} {
      lappend menuListe $Zeile
      }
    close $Datei} else {
   set menuListe "{ {} Nothing}"
    }
  return $menuListe
  }

###########################################################################
# Load menu-description for gv_menuconf-proc:                             #
###########################################################################

proc ladeInMenuliste {} {
        
  global menuListe menulistnr
   
  set datname menu$menulistnr.dat
       
  catch {unset menuListe}
  catch {unset Datei}
  set menuListe ""
  cd ~/
# set Datei [open $datname r+]
  set datinfo [catch {set Datei [open $datname r+]}]
  if {$datinfo == 0} {
    while {[gets $Datei Zeile] >= 0} {
      lappend menuListe $Zeile
      }
    close $Datei} else {
   set menuListe "{ {} Nothing}"
    }
  return $menuListe
  }

###########################################################################
# Define Special-Menus:                                                   #
###########################################################################

proc gv_mm2 {} {

global main menuListe info commandvar
  
  catch {destroy .mm2}
  menu .mm2
  ladeInMenuliste2
  foreach element $menuListe {
    .mm2 add radiobutton -variable commandvar$main -value [lindex $element 0] \
       -label [lindex $element 1] -command {
        
        catch {eval eval exec \$commandvar$main}
        }
        }
  eval {.mm2 post [expr [winfo pointerx .]] [expr [winfo pointery .]]}
  bind .mm2 <Leave> {.mm2 unpost}
}

###########################################################################
# Configuration - Menu:                                                   #
###########################################################################

proc gv_confmenu {} {

global delnr g2 menuListe menulistnr deld
 
  catch {destroy .menuw}
  catch {destroy menuListe}
  catch {destroy element}
  toplevel .menuw -class Dialog
  wm title .menuw "Menu - Configuration"
  frame .menuw.top 
  frame .menuw.bottom
  frame .menuw.top.left -relief ridge -borderwidth 4
  frame .menuw.top.right 
  pack .menuw.top .menuw.bottom -in .menuw -side top -fill x
  pack .menuw.top.left -in .menuw.top -side top -padx 1m -pady 1m
  pack .menuw.top.right -in .menuw.top -side top -fill both
  set menuListe ""
  ladeInMenuliste
  set g2 0
  set g23 0
  set deld ""
  
###########################################################################
# Make Headline:                                                          #
###########################################################################

  frame .menuw.top.left.headframe -width 15c
  frame .menuw.top.left.headframe.f1 -width 1c
  frame .menuw.top.left.headframe.f2 -width 1c
  label .menuw.top.left.headframe.f1.label1 -text Menucommand: -anchor w
  label .menuw.top.left.headframe.f2.label2 -text Menuname: -anchor w
  pack .menuw.top.left.headframe.f1.label1 -in .menuw.top.left.headframe.f1 \
    -side left
  pack .menuw.top.left.headframe.f2.label2 -in .menuw.top.left.headframe.f2 \
    -side left    
  pack .menuw.top.left.headframe.f1 .menuw.top.left.headframe.f2 \
    -in .menuw.top.left.headframe -side left -fill none -expand 1
  pack .menuw.top.left.headframe -in .menuw.top.left -side top -expand 1 -fill x

###########################################################################  
# Add newline:                                                            #
###########################################################################

  button .menuw.bottom.add -text "Add" -anchor w -command {
    incr g2
    frame .menuw.top.left.frame$g2 -width 15c
    entry .menuw.top.left.frame$g2.entry1$g2 -width 15 -relief sunken -bd 2\
          -textvariable menucommand$g2

    entry .menuw.top.left.frame$g2.entry2$g2 -width 15 -relief sunken -bd 2 \
          -textvariable menuname$g2

###########################################################################    
# Delete Entry routine:                                                   #
###########################################################################

    button .menuw.top.left.frame$g2.button$g2 -text Delete \
      -textvariable delvar$g2 -anchor w -command {
      after 100 {
        if {$delnr != 0} {
          destroy .menuw.top.left.frame$delnr
          lappend deld $delnr
          } else {
          .menuw.top.left.frame0.entry10 delete 0 end
          .menuw.top.left.frame0.entry20 delete 0 end
          }
        }
      }
    trace variable delvar$g2 r gv_TraceProcDel
    pack .menuw.top.left.frame$g2.button$g2 \
    .menuw.top.left.frame$g2.entry1$g2 .menuw.top.left.frame$g2.entry2$g2 \
    -in .menuw.top.left.frame$g2 -side left

    pack .menuw.top.left.frame$g2 -in .menuw.top.left -side top
  }

###########################################################################  
# Build Body (simular to Add):                                            #
###########################################################################

  foreach element $menuListe {
    frame .menuw.top.left.frame$g2 -width 15c
    entry .menuw.top.left.frame$g2.entry1$g2 -width 15 -relief sunken -bd 2\
          -textvariable menucommand$g2
    .menuw.top.left.frame$g2.entry1$g2 insert insert [lindex $element 0]

    entry .menuw.top.left.frame$g2.entry2$g2 -width 15 -relief sunken -bd 2 \
          -textvariable menuname$g2
    .menuw.top.left.frame$g2.entry2$g2 insert insert [lindex $element 1]

###########################################################################    
# Delete Entry routine:                                                   #
###########################################################################

    button .menuw.top.left.frame$g2.button$g2 -text Delete \
      -textvariable delvar$g2 -anchor w -command {
      after 100 {
        if {$delnr != 0} {
          destroy .menuw.top.left.frame$delnr
          lappend deld $delnr
          } else {
          .menuw.top.left.frame0.entry10 delete 0 end
          .menuw.top.left.frame0.entry20 delete 0 end
          }
        }
      }
    pack .menuw.top.left.frame$g2.button$g2 \
    .menuw.top.left.frame$g2.entry1$g2 .menuw.top.left.frame$g2.entry2$g2 \
    -in .menuw.top.left.frame$g2 -side left

    pack .menuw.top.left.frame$g2 -in .menuw.top.left -side top
    incr g2
    }
    if {$g2>0} {
      set g2 [expr $g2 - 1]}

  after 100 {
    for {set g23 0} {$g23<=$g2} {incr g23} {
      trace variable delvar$g23 r gv_TraceProcDel
    }
  }

###########################################################################    
# Cancel Entry                                                            #
###########################################################################

  label .menuw.bottom.info -text "Use the middle button for this menu."
  pack .menuw.bottom.info -in .menuw.bottom
  button .menuw.bottom.cancel -text Cancel -anchor w -command {
    for {set i2 0} {$i2 <= $g2} {incr i2} {
        set menucommand$i2 ""
        set menuname$i2 ""
        unset menucommand$i2
        unset menuname$i2
        }
    set deld ""
    unset deld
    destroy .menuw
    }
    
###########################################################################    
# Save Entry and exit:                                                    #
###########################################################################    
    
  button .menuw.bottom.ok -text OK -anchor w -command {

    set stop 0
    cd ~/
    set datname2 menu$menulistnr.dat
    set Datei [open $datname2 w+]
    for {set i2 0} {$i2 <= $g2} {incr i2} {
      set stop 0
      foreach elementD $deld {
        if {$i2 == $elementD} {
          set stop 1}
        }
      if {$stop == 0} { 
      set s1 "list \"\$menucommand$i2\" \"\$menuname$i2\""
      puts $Datei [eval "$s1"]}
      }
    close $Datei
    for {set i2 0} {$i2 <= $g2} {incr i2} {
        set menucommand$i2 ""
        set menuname$i2 ""
        unset menucommand$i2
        unset menuname$i2
        }
    set deld ""
    unset deld
    destroy .menuw
    }
        
  pack .menuw.bottom.add .menuw.bottom.ok .menuw.bottom.cancel -in .menuw.bottom -side left -fill x

  wm withdraw .menuw
  update idletasks
  set x [expr [winfo screenwidth .menuw]/2 -[winfo reqwidth .menuw]/2 - [winfo vrootx [winfo parent .menuw]]]
  set y [expr [winfo screenheight .menuw]/2 -[winfo reqheight .menuw]/2 - [winfo vrooty [winfo parent .menuw]]]
  wm geom .menuw +$x+$y
  wm deiconify .menuw
  grab set .menuw
}